<?php
/**
 Easy Syntax Highlighter
 Copyright (C) 2009 by Neil Burlock
 Homepage   : www.burlock.org
 Author     : Neil Burlock
 Email      : neil@burlock.org
 Version    : 1.0.0
 License    : http://www.gnu.org/copyleft/gpl.html GNU/GPL
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemEasysyntaxhighlighter extends JPlugin
{
	function plgSystemEasysyntaxhighlighter(&$subject, $config)
	{
		parent::__construct($subject, $config);
    $this->_plugin = JPluginHelper::getPlugin('system', 'easysyntaxhighlighter');
    $this->_params = new JParameter( $this->_plugin->params );
	}
	
  // Scan the body and extract the brushes that need to be included
  function extractBrushes() {
	  $selected = array();
	
	  // Fetch the key_tag_name tags in the body
	  if (preg_match_all('/<'.$this->params->get('tag_name', 'pre').'.+?>/', JResponse::getBody(), $matches) > 0) {
				  // Got the brush, translate it into the equivalent js file
				  $brushes = array('shBrushAS3.js' => array('as3', 'actionscript3'),
								   'shBrushBash.js' => array('bash', 'shell'),
								   'shBrushCSharp.js' => array('c-sharp', 'csharp'),
								   'shBrushCpp.js' => array('cpp', 'c'),
								   'shBrushCss.js' => array('css'),
								   'shBrushDelphi.js' => array('delphi', 'pas', 'pascal'),
								   'shBrushDiff.js' => array('diff', 'patch'),
								   'shBrushGroovy.js' => array('groovy'),
								   'shBrushJScript.js' => array('js', 'jscript', 'javascript'),
								   'shBrushJava.js' => array('java'),
								   'shBrushJavaFX.js' => array('jfx', 'javafx'),
								   'shBrushPerl.js' => array('perl', 'pl'),
								   'shBrushPhp.js' => array('php'),
								   'shBrushPlain.js' => array('plain', 'text'),
								   'shBrushPowerShell.js' => array('ps', 'powershell'),
								   'shBrushPython.js' => array('py', 'python'),
								   'shBrushRuby.js' => array('rails', 'ror', 'ruby'),
								   'shBrushScala.js' => array('scala'),
								   'shBrushSql.js' => array('sql'),
								   'shBrushVb.js' => array('vb', 'vbnet'),
							   	 'shBrushXml.js' => array('xml', 'xhtml', 'xslt', 'html', 'xhtml'));
				  $files = array_keys($brushes);
		
		  // For each tag, extract the class clause, assuming it is like "brush: brushname"
		  foreach ($matches[0] as $match) {
			  if (preg_match_all('/brush *: *[a-zA-Z0-9_\.]*/', $match, $brush) == 1) {
				  $brush = explode(":", $brush[0][0]);
				  $brush = strtolower(trim($brush[1]));
				  foreach ($files as $file) {
					  if (in_array($brush, $brushes[$file])) {
						  if (!in_array($file, $selected)) {
							  array_push($selected, $file);
							  break;
						  }
					  }
				  }
			  }
		  }
	  }
		
	  // Save the selected brushes list
    $brushes = "";
    foreach ($selected as $brush) {
      $brushes .= "<script type='text/javascript' src='".JURI::root()."plugins/system/easysyntaxhighlighter/scripts/$brush'></script>\n";
    }
    return $brushes;
  }

  function includeBrush($param, $brush) {
    if ($this->params->get($param, '0') == '1') return "<script type='text/javascript' src='".JURI::root()."plugins/system/easysyntaxhighlighter/scripts/$brush'></script>\n";
    else return "";
  }

	function onAfterRender()
	{
		global $mainframe;

    // No highlighting while in the admin pages
    if ($mainframe->isAdmin()) return;

    $buffer = JResponse::getBody();
		$script =  "<script type='text/javascript' src='".JURI::root()."plugins/system/easysyntaxhighlighter/scripts/shCore.js'></script>\n";

    // If auto brushes is enabled, then scan the body for code tags to work out which tags to use
    if ($this->params->get('auto_brushes', '0') != '0') {
      $script .= $this->extractBrushes();
    } else {
    	$script .= $this->includeBrush("brush_as3","shBrushAS3.js");
    	$script .= $this->includeBrush("brush_bash","shBrushBash.js");
    	$script .= $this->includeBrush("brush_cpp","shBrushCpp.js");
    	$script .= $this->includeBrush("brush_csharp","shBrushCSharp.js");
    	$script .= $this->includeBrush("brush_css","shBrushCss.js");
    	$script .= $this->includeBrush("brush_delphi","shBrushDelphi.js");
    	$script .= $this->includeBrush("brush_diff","shBrushDiff.js");
    	$script .= $this->includeBrush("brush_groovy","shBrushGroovy.js");
    	$script .= $this->includeBrush("brush_java","shBrushJava.js");
    	$script .= $this->includeBrush("brush_javafx","shBrushJavaFX.js");
    	$script .= $this->includeBrush("brush_javascript","shBrushJScript.js");
    	$script .= $this->includeBrush("brush_perl","shBrushPerl.js");
    	$script .= $this->includeBrush("brush_php","shBrushPhp.js");
    	$script .= $this->includeBrush("brush_plain","shBrushPlain.js");
    	$script .= $this->includeBrush("brush_powershell","shBrushPowerShell.js");
    	$script .= $this->includeBrush("brush_python","shBrushPython.js");
    	$script .= $this->includeBrush("brush_ruby","shBrushRuby.js");
    	$script .= $this->includeBrush("brush_scala","shBrushScala.js");
    	$script .= $this->includeBrush("brush_sql","shBrushSql.js");
    	$script .= $this->includeBrush("brush_vb","shBrushVb.js");
    	$script .= $this->includeBrush("brush_xml","shBrushXml.js");
    }

    // If the parameter value isn't equal to the default, then specify it as part of the script
    $script .= "<script type='text/javascript'>\n";
    if ($this->params->get('clipboard_swf', '1') == '1') $script .= "SyntaxHighlighter.config.clipboardSwf = '".JURI::root()."plugins/system/easysyntaxhighlighter/scripts/clipboard.swf';\n";
    if ($this->params->get('strip_brs', '0') != '0') $script .= "SyntaxHighlighter.config.stripBrs = true;\n";
    if ($this->params->get('toolbar_item_width', '16') != '16') $script .= "SyntaxHighlighter.config.toolbarItemWidth = ".$this->params->get('toolbar_item_width', '16').";\n";
    if ($this->params->get('toolbar_item_height', '16') != '16') $script .= "SyntaxHighlighter.config.toolbarItemHeight = ".$this->params->get('toolbar_item_height', '16').";\n";
    if ($this->params->get('tag_name', 'pre') != 'pre') $script .= 'SyntaxHighlighter.config.tagName = "'.$this->params->get('tag_name', 'pre').'";'."\n";

    if ($this->params->get('expand_source', '+ expand source') != '+ expand source') $script .= 'SyntaxHighlighter.config.strings.expandSource = "'.$this->params->get('expand_source', '+ expand source').'"'.";\n";
    if ($this->params->get('view_source', 'view source') != 'view source') $script .= 'SyntaxHighlighter.config.strings.viewSource = "'.$this->params->get('view_source', 'view source').'"'.";\n";
    if ($this->params->get('copy_to_clipboard', 'copy to clipboard') != 'copy to clipboard') $script .= 'SyntaxHighlighter.config.strings.copyToClipboard = "'.$this->params->get('copy_to_clipboard', 'copy to clipboard').'"'.";\n";
    if ($this->params->get('copy_to_clipboard_confirmation', 'The code is in your clipboard now') != 'The code is in your clipboard now') $script .= 'SyntaxHighlighter.config.strings.copyToClipboardConfirmation = "'.$this->params->get('copy_to_clipboard_confirmation', 'The code is in your clipboard now').'"'.";\n";
    if ($this->params->get('print', 'print') != 'print') $script .= 'SyntaxHighlighter.config.strings.print = "'.$this->params->get('print', 'print').'"'.";\n";
    if ($this->params->get('help', '?') != '?') $script .= 'SyntaxHighlighter.config.strings.help = "'.$this->params->get('help', '?').'"'.";\n";
    if ($this->params->get('alert', 'SyntaxHighlighter:') != 'SyntaxHighlighter:') $script .= 'SyntaxHighlighter.config.strings.alert = "'.$this->params->get('alert', 'SyntaxHighlighter:').'"'.";\n";
    if ($this->params->get('no_brush', "Can't find brush for:") != "Can't find brush for:") $script .= 'SyntaxHighlighter.config.strings.noBrush = "'.$this->params->get('no_brush', "Can't find brush for:").'";'."\n";
    if ($this->params->get('brush_not_html_script', "Brush wasn't made for html-script option:") != "Brush wasn't made for html-script option:") $script .= 'SyntaxHighlighter.config.strings.brushNotHtmlScript = "'.$this->params->get('brush_not_html_script', "Brush wasn't made for html-script option:").'"'.";\n";

  	$script .=  "SyntaxHighlighter.config.bloggerMode = true;\nSyntaxHighlighter.all();</ScripT>\n";
 		
    // Insert the highlighter CSS before the templace CSS so that the template can override it
    $pos = strrpos($buffer, '<head>');
		if($pos > 0) {
      $pos += 6;
			$buffer = substr($buffer, 0, $pos)."
<link href='".JURI::root()."plugins/system/easysyntaxhighlighter/styles/shCore.css' type='text/css' rel='stylesheet'/>
<link href='".JURI::root()."plugins/system/easysyntaxhighlighter/styles/".$this->params->get('theme', 'shThemeDefault.css')."' type='text/css' rel='stylesheet' id='shTheme'/>".substr($buffer, $pos);
		}

    // Insert the rest of the script files at the end of the body
		$pos = strrpos($buffer, "</body>");
		if($pos > 0) {
			$buffer = substr($buffer, 0, $pos).$script.substr($buffer, $pos);
		}
  	JResponse::setBody($buffer);
		
		return true;
	}
}
?>
